diff --git a/hubs/views/utils.py b/hubs/views/utils.py
index a90e468..0a89595 100644
--- a/hubs/views/utils.py
+++ b/hubs/views/utils.py
@@ -1,15 +1,16 @@
 from __future__ import unicode_literals
 
 import datetime
-import flask
 import functools
 import logging
 
-from hubs.models import Hub, Widget
+import flask
 from six.moves.urllib import parse as urlparse
 from sqlalchemy.orm import joinedload
 from sqlalchemy.orm.exc import NoResultFound
 
+from hubs.models import Hub, Widget
+
 
 log = logging.getLogger(__name__)
 
@@ -44,6 +45,27 @@ def get_widget_instance(hub, idx, session=None):
         flask.abort(404)
 
 
+def get_visible_widgets(hub):
+    from hubs.widgets import registry
+    widgets = {"left": [], "right": []}
+    for widget in hub.widgets:
+        if widget.plugin not in registry:
+            continue  # disabled widget
+        try:
+            user = flask.g.auth.user
+        except AttributeError:
+            user = None
+        if not widget.allows(user, "view"):
+            continue
+        if widget.left:
+            widgets["left"].append(widget)
+        else:
+            widgets["right"].append(widget)
+    widgets["left"].sort(key=lambda w: w.index)
+    widgets["right"].sort(key=lambda w: w.index)
+    return widgets
+
+
 class WidgetConfigError(Exception):
     pass
 
@@ -127,6 +149,38 @@ def login_required(function):
     return decorated_function
 
 
+def require_hub_access(action, url_param="name", json=False):
+    """Check access to the hub for the specified action."""
+    def decorator(function):
+        @functools.wraps(function)
+        def wrapper(*args, **kwargs):
+            hub_name = kwargs[url_param]
+            hub = get_hub(hub_name, load_config=True)
+            try:
+                user = flask.g.auth.user
+            except AttributeError:
+                user = None
+            if not hub.allows(user, action):
+                if action == "view":
+                    msg = "This hub is for members only."
+                elif action == "config":
+                    msg = "You are not allowed to configure this hub."
+                else:
+                    msg = "Access forbidden."
+                if json:
+                    result = flask.jsonify({
+                        "status": "ERROR", "message": msg, "hub": hub.name,
+                        })
+                else:
+                    result = flask.render_template(
+                        'errors/hub.html', hub=hub, msg=msg,
+                        )
+                return result, 403
+            return function(*args, **kwargs)
+        return wrapper
+    return decorator
+
+
 def is_safe_url(target):
     """ Checks that the target url is safe and sending to the current
     website not some other malicious one.
diff --git a/hubs/views/widget.py b/hubs/views/widget.py
index 39bb8f7..35fb12a 100644
--- a/hubs/views/widget.py
+++ b/hubs/views/widget.py
@@ -8,11 +8,13 @@ from pkg_resources import resource_isdir
 from .utils import (
     create_widget_instance, configure_widget_instance, get_hub,
     get_widget_instance, login_required, WidgetConfigError,
-    get_position,
+    get_position, require_hub_access,
     )
 
 
 @app.route('/<name>/add', methods=['GET', 'POST'])
+@login_required
+@require_hub_access("config")
 def hub_add_widget(name):
     hub = get_hub(name)
     position = get_position()
@@ -45,6 +47,8 @@ def hub_add_widget(name):
 
 
 @app.route('/<hub>/add/<widget>', methods=['GET', 'POST'])
+@login_required
+@require_hub_access("config", url_param="hub")
 def widget_add(hub, widget):
     hub = get_hub(hub)
     position = get_position()
@@ -65,6 +69,7 @@ def widget_add(hub, widget):
 
 @app.route('/<hub>/<int:idx>/edit', methods=['GET', 'POST'])
 @login_required
+@require_hub_access("config", url_param="hub")
 def widget_edit(hub, idx):
     widget_instance = get_widget_instance(hub, idx)
     if flask.request.method == 'POST':
@@ -85,6 +90,7 @@ def widget_edit(hub, idx):
 
 @app.route('/<hub>/<int:idx>/delete', methods=['POST'])
 @login_required
+@require_hub_access("config", url_param="hub")
 def widget_edit_delete(hub, idx):
     ''' Remove a widget from a hub. '''
     widget_instance = get_widget_instance(hub, idx)
@@ -100,6 +106,7 @@ def widget_edit_delete(hub, idx):
 
 
 @app.route('/<hub>/<int:idx>/json')
+@require_hub_access("view", url_param="hub")
 def widget_json(hub, idx):
     widget = get_widget_instance(hub, idx)
     response = flask.jsonify(widget.__json__())
diff --git a/hubs/widgets/halp/views.py b/hubs/widgets/halp/views.py
index 264da3d..f1aae71 100644
--- a/hubs/widgets/halp/views.py
+++ b/hubs/widgets/halp/views.py
@@ -7,7 +7,7 @@ import flask
 from flask.signals import template_rendered, before_render_template
 
 from hubs.models import Hub
-from hubs.views.utils import get_hub
+from hubs.views.utils import get_hub, require_hub_access
 from hubs.widgets import registry
 from hubs.widgets.base import WidgetView
 from .functions import GetRequests
@@ -33,9 +33,9 @@ class DataView(WidgetView):
 
     name = "data"
     url_rules = ["data"]
+    json = True
 
-    def dispatch_request(self, *args, **kwargs):
-        instance = self._get_instance(*args, **kwargs)
+    def get_context(self, instance, *args, **kwargs):
         get_requests = GetRequests(instance)
         data = {"requests": []}
         hubs_filter = flask.request.args.getlist("hubs")
@@ -55,7 +55,7 @@ class DataView(WidgetView):
             if len(data["requests"]) == 3:
                 # Only 3 requests on the main widget.
                 break
-        return flask.jsonify(data)
+        return data
 
 
 class SearchView(WidgetView):
@@ -64,9 +64,9 @@ class SearchView(WidgetView):
     name = "search"
     url_rules = ["search"]
     methods = ['GET', 'POST']
+    json = True
 
-    def dispatch_request(self, *args, **kwargs):
-        instance = self._get_instance(*args, **kwargs)
+    def get_context(self, instance, *args, **kwargs):
         get_requests = GetRequests(instance)
         # prepare filters
         if "hubs" in flask.request.values:
@@ -112,7 +112,7 @@ class SearchView(WidgetView):
             data["requests"], instance.config["per_page"])
         data["requests"] = requests
         data["page"] = page_data
-        return flask.jsonify(data)
+        return data
 
 
 class RequestersView(WidgetView):
@@ -121,9 +121,9 @@ class RequestersView(WidgetView):
     name = "requesters"
     url_rules = ["requesters"]
     MAX_SUGGESTS = 5
+    json = True
 
-    def dispatch_request(self, *args, **kwargs):
-        instance = self._get_instance(*args, **kwargs)
+    def get_context(self, instance, *args, **kwargs):
         get_requests = GetRequests(instance)
         results = set([
             req["author"]["name"] for req in get_requests()
@@ -132,7 +132,7 @@ class RequestersView(WidgetView):
         if query:
             results = [name for name in results if name.startswith(query)]
         results = sorted(list(results))[:self.MAX_SUGGESTS]
-        return flask.jsonify({"results": results})
+        return {"results": results}
 
 
 class ConfigView(WidgetView):
@@ -143,6 +143,7 @@ class ConfigView(WidgetView):
     name = "config"
     url_rules = ["config"]
     template_name = "halp_config.html"
+    permission = "config"
 
     def get_context(self, instance, *args, **kwargs):
         post_url = flask.url_for(
@@ -168,6 +169,7 @@ def hubs_suggest_view():
     return flask.jsonify({"results": [h.name for h in results]})
 
 
+@require_hub_access("config", url_param="hub")
 def add_view(hub):
     """The custom configuration panel when adding the widget.
 
@@ -188,7 +190,9 @@ def add_view(hub):
         )
     initial["hubs"] = [hub.name]
     context = dict(mode="add", url=post_url, initial=initial)
-    before_render_template.send(widget, template=template, context=context)
+    before_render_template.send(
+        flask.current_app, template=template, context=context)
     output = template.render(**context)
-    template_rendered.send(widget, template=template, context=context)
+    template_rendered.send(
+        flask.current_app, template=template, context=context)
     return output
diff --git a/hubs/widgets/view.py b/hubs/widgets/view.py
index 943302d..f02e777 100644
--- a/hubs/widgets/view.py
+++ b/hubs/widgets/view.py
@@ -1,5 +1,6 @@
 from __future__ import unicode_literals, absolute_import
 
+import flask
 from flask.signals import template_rendered, before_render_template
 from flask.views import View
 
@@ -44,6 +45,8 @@ class WidgetView(View):
     name = None
     url_rules = []
     template_name = None
+    json = False
+    permission = "view"
 
     def __init__(self, widget):
         """
@@ -96,12 +99,30 @@ class WidgetView(View):
         implement. It binds the other methods together.
         """
         instance = self._get_instance(*args, **kwargs)
+        try:
+            user = flask.g.auth.user
+        except AttributeError:
+            user = None
+        if not instance.allows(user, self.permission):
+            msg = "You are not allowed to access this widget."
+            if self.json:
+                result = flask.jsonify({
+                    "status": "ERROR", "message": msg,
+                    })
+            else:
+                result = flask.render_template(
+                    'errors/hub.html', hub=instance.hub, msg=msg,
+                    )
+            return result, 403
         context = self.get_context(instance, *args, **kwargs)
-        context.update(self.get_extra_context(instance, *args, **kwargs))
-        template = self.get_template()
-        before_render_template.send(
-            self.widget, template=template, context=context)
-        output = template.render(**context)
-        template_rendered.send(
-            self.widget, template=template, context=context)
-        return output
+        if self.json:
+            return flask.jsonify(context)
+        else:
+            context.update(self.get_extra_context(instance, *args, **kwargs))
+            template = self.get_template()
+            before_render_template.send(
+                flask.current_app, template=template, context=context)
+            output = template.render(**context)
+            template_rendered.send(
+                flask.current_app, template=template, context=context)
+            return output
